<template>
  <div class="contract-directions">
    <div class="contract-directions__header">
      <button data-qa="btnContractDirectionsHeader" @click="setViewState(VIEW_STATES.main)">
        <i class="icon chevron-left" />
        {{ serviceTitleByType }}
      </button>
      <div class="title">
        {{ service.serviceTitle }}
      </div>
    </div>

    <ObTable
      ref="directionTable"
      :columns="columns"
      :page-limit="15"
      :remote-opt="{
        method: api.contract.getServiceDirections,
        arguments: {
          uuid: service.uuid
        }
      }"
      :remote-trigger="service.geography === 'FROM_TO' ? service.uuid : undefined"
      group-by="locationTitleFrom"
      :group-title-html="tableGroupTitleHtml"
      :show-add-button="isDraft"
      :functional-panel="true"
      add-button-text="Добавить направление"
      data-qa="contractDirectionsTable"
      @add="onAddDirection"
      @select="selectDirection"
    >
      <div slot="dropdownMenu" slot-scope="{ data }">
        <ObMenuDropdown
          :items="getDropdownItems(data)"
        />
      </div>
      <template slot="noneContent">
        <div class="title">Сейчас услуга действует для всех направлений по онлайн-ценам.</div>
        <ObButton
          v-if="isDraft"
          label="Добавить направление"
          type="flat"
          data-qa="addDirection"
          @click="onAddDirection"
        />
      </template>
      <template v-slot:extraFuncToPanel>
        <div class="contract-directions-functional">
          <div class="contract-directions__select-inline">
            <span>Группировка: </span>
            <ob-inline-select
              v-model="listFilter.uuid"
              :items="listFilters"
            />
          </div>
          <div class="contract-directions__select-inline" :class="['disabled']">
            <span>Тарифы на: </span>
            <ob-inline-select
              v-model="date.uuid"
              :items="dates"
            />
          </div>
          <ObSwitcher v-model="switcher" label-right="Скрывать неактивные"/>
        </div>
      </template>
    </ObTable>
    <ObModal
      ref="directionModal"
      :title-second="titleSecondModal"
      :title="titleModal"
      size="large"
      data-qa="contractDirection"
    >
      <component
        :is="directionFormComponent"
        :data-source="editedData"
        @on-disable-direction="deleteDirection"
        @submit="saveDirection"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import { mapState, mapGetters, mapMutations } from 'vuex'
import ObTable from 'common-components/src/obComponents/obTable'
import DirectionForm from '@/components/Contract/detail/services/directions/Form'
import DirectionFormAdditional from '@/components/Contract/detail/services/directions/FormAdditional'
import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
import ObSwitcher from "common-components/src/obComponents/obSwitcher"
import { formatNumber } from 'common-components/src/helpers/common'
import moment from 'moment';

export default {
  name: 'ContractDirectionsList',
  components: {
    ObTable,
    DirectionForm,
    ObModal,
    ObMenuDropdown,
    ObButton,
    ObInlineSelect,
    ObSwitcher
  },
  data () {
    return {
      api,
      editedData: {},
      listFilter: {
        uuid: 'from'
      },
      listFilters: [
        {
          uuid: 'from',
          title: 'Откуда'
        }
      ],
      date: {
        uuid: 'today'
      },
      dates: [
        {
          uuid: 'today',
          title: moment().format('DD.MM.YYYY')
        }
      ],
      switcher: false
    }
  },
  computed: {
    ...mapState({
      contract: state => state.contract.contract,
      service: state => state.contract.editedService
    }),
    ...mapGetters({
      isDraft: 'contract/isDraft',
      VIEW_STATES: 'contract/VIEW_STATES',
      isVatPayer: 'contract/isDoerVatPayer'
    }),
    directionFormComponent () {
      const componentMap = {
        base: DirectionForm,
        additional: DirectionFormAdditional
      }
      return componentMap[this.service.type] || DirectionForm
    },
    columns () {
      return [
        {
          title: ' ',
          key: 'locationTitleFrom',
          sortDisable: true,
          html: () => '',
          width: 80
        },
        {
          title: 'Куда',
          key: 'locationTitleTo',
          html: (data) => {
            return data.locationTitleTo
          }
        },
        {
          title: 'Тариф (без ндс)',
          key: 'tariff',
          html: (data) => this.tariffHtml(data)
        },
        {
          title: this.getNdsTitle(),
          key: 'vatAmount',
          html: (data) => this.ndsHtml(data)
        },
        {
          title: 'Итоговый тариф',
          key: 'total',
          html: (data) => this.totalPrice(data)
        },
        {
          title: ' ',
          slotName: 'dropdownMenu',
          sortDisable: true,
          action: true
        }
      ]
    },
    serviceTitleByType () {
      if (!this.service.type) return ''
      let types = [
        {
          uuid: 'SIMPLE',
          title: 'Базовые'
        },
        {
          uuid: 'MULTISTOP',
          title: 'Мультистоповые',
          isDisabled: true
        },
        {
          uuid: 'MULTIMODAL',
          title: 'Мультимодальные',
          isDisabled: true
        },
        {
          uuid: 'ADDITIONAL',
          title: 'Дополнительные',
          isDisabled: true
        }
      ]

      return types.find((item) => item.uuid === this.service.type).title
    },
    titleModal () {
      return this.editedData.directionUuid ? `Направление «${this.editedData.locationTitleFrom} → ${this.editedData.locationTitleTo}»` : 'Направление'
    },
    titleSecondModal () {
      if (!this.isDraft) {
        return 'Просмотр'
      }
      return this.editedData.directionUuid ? 'Редактирование' : 'Добавление'
    }
  },
  methods: {
    ...mapMutations({
      setViewState: 'contract/setViewState'
    }),
    onAddDirection () {
      this.editedData = {}
      this.$refs.directionModal.open()
    },
    async deleteDirection ({ uuid }) {
      try {
        await api.contract.deleteDirection({ uuid })
        this.$notification({
          type: 'system_notification_success',
          message: `Направление удалено`
        })
        setTimeout(() => {
          this.$refs.directionTable.loadData()
        }, 500)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка удаления направления`
        })
      }
    },
    async saveDirection ({ formData }) {
      formData.serviceUuid = this.service.uuid
      try {
        if (formData.directionUuid) {
          await api.contract.updateDirectionOld({ data: formData, uuid: formData.directionUuid })
        } else {
          await api.contract.createDirectionOld({ data: formData, uuid: this.service.uuid })
        }
        this.$notification({
          type: 'system_notification_success',
          message: `Направление ${this.editedService ? 'обновлено' : 'добавлено'}`
        })
        this.$refs.directionModal.close()
        setTimeout(() => {
          this.$refs.directionTable.loadData()
        }, 500)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} направления`
        })
      }
    },
    async selectDirection (data) {
      try {
        let res = await api.contract.getDirectionDetail({ uuid: data.directionUuid })
        this.editedData = { ...res }
        this.$refs.directionModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных направления`
        })
      }
    },
    getDropdownItems (data) {
      if (!this.isDraft) {
        return []
      }
      return [
        {
          title: 'Удалить направление',
          className: 'menu-button-danger',
          method: () => this.deleteDirection({ uuid: data.item.directionUuid })
        }
      ]
    },
    toHtml (data) {
      return `<div class="cell-to-direction"><i class="icon ${data.to_icon}"></i><span>${data.to}</span></div>`
    },
    tariffHtml (data) {
      if (!data.tariffWithoutVat) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariffWithoutVat / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    ndsHtml (data) {
      return this.isVatPayer ? (formatNumber(data.vatAmount / 100, { dot: 2 }) + ' ₽') : `<span class="-gray-window">Не облагается</span>`
    },
    totalPrice(data) {
      if (!data.tariff) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariff / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    tableGroupTitleHtml (value) {
      return `<div class="cell-to-direction"><i class="icon city-sm"></i><span>${value}</span></div>`
    },
    getNdsTitle () {
      if (!this.isVatPayer) {
        return 'НДС'
      }
      return this.service.isVatInclude ? 'в том числе НДС ' + (this.service.vatValue || 20) + '%' :
        'НДС ' + (this.service.vatValue || 20) + '%'
    }
  }
}
</script>

<style lang="scss" scoped>
  .contract-directions {
    display: flex;
    flex-direction: column;
    height: 100%;
    background-color: $background-white;
    border-radius: 3px;
    &__header {
      display: flex;
      align-items: center;
      min-height: 60px;
      padding: 20px 13px;
      border-bottom: 1px $color-grey-border solid;
      button {
        display: flex;
        align-items: center;
        margin: 0;
        padding: 5px;
        background-color: transparent;
        border: none;
        color: $color-blue-navy-blue;
        font-size: 16px;
        line-height: 20px;
        outline: none;
        cursor: pointer;
        .icon {
          margin-right: 10px;
          font-size: 18px;
        }
      }
      .title {
        margin-left: 50px;
        font-family: Roboto, sans-serif;
        font-style: normal;
        font-weight: normal;
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $color-text-base;
      }
    }
    &-functional {
      display: flex;
      align-items: center;
      flex: 1;
    }
    &__select-inline {
      padding: 7px 12px;
      margin-right: 12px;
      background: $lavender;
      border-radius: 19px;
      &.disabled {
        background: $color-white-lilac;
        pointer-events: none;
      }
      span {
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: $color-grey-span;
      }
    }
    &::v-deep {
      .ob-func-panel__controls-side:last-child {
        flex-grow: 2;
        justify-content: space-between;
      }
    }
  }
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  .contract-directions {
    table {
      min-width: auto!important;
    }
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .ob-table-inner {
      flex-grow: 2;
      .ob-menu-dropdown-container:not(.--opened) {
        opacity: 0;
        pointer-events: none;
      }
      tr:hover {
        .ob-menu-dropdown-container {
          opacity: 1;
          pointer-events: all;
        }
      }
      td {
        &:last-child {
          .td-container {
            justify-content: flex-end;
          }
        }
      }
      .cell-to-direction {
        display: flex;
        align-items: center;
        .icon {
          margin-right: 10px;
          font-size: 14px;
          color: $color-blue-navy-blue;
        }
      }
    }
  }
</style>
